// Start Emu Plus
/* PacMAME */
/***************************************************************************

  machine.c

  Functions to emulate general aspects of the machine (RAM, ROM, interrupts,
  I/O ports)

***************************************************************************/

#include "driver.h"

static int speedcheat = 0;	/* a well known hack allows to make Pac Man run at four times */
					/* his usual speed. When we start the emulation, we check if the */
					/* hack can be applied, and set this flag accordingly. */


void plusfast_init_machine(void)
{
	unsigned char *RAM = memory_region(REGION_CPU1);


	/*
	if ((RAM[0x180b] == 0xbe && RAM[0x1ffd] == 0x00) ||
			(RAM[0x180b] == 0x01 && RAM[0x1ffd] == 0xbd))
		speedcheat = 1;
	else
		speedcheat = 0;
	*/

	if ((RAM[0x182d] == 0xbe && RAM[0x1ffd] == 0xff) ||
			(RAM[0x182d] == 0x01 && RAM[0x1ffd] == 0xbe))
		speedcheat = 1;
	else speedcheat = 0;

}

int plusfast_interrupt(void)
{
	unsigned char *RAM = memory_region(REGION_CPU1);


	if (speedcheat)
	{
		if (readinputport(4) & 1)	/* check status of the fake dip switch */
		{
			RAM[0x182d] = 0x01;
			RAM[0x1ffd] = 0xbe;
		}
		else
		{
			RAM[0x182d] = 0xbe;
			RAM[0x1ffd] = 0xff;
		}
	}
/*
	if (speedcheat)
	{
		if (readinputport(4) & 1)
		{
			RAM[0x180b] = 0x01;
			RAM[0x1ffd] = 0xbd;
		}
		else
		{
			RAM[0x180b] = 0xbe;
			RAM[0x1ffd] = 0x00;
		}
	}
*/
	return interrupt();
}
/* End PacMAME */
// End Emu Plus
